import { Component, ElementRef, ViewChild, ViewEncapsulation } from '@angular/core';

@Component({
  selector: 'dush-magic-string',
  template: `
    <input type="text" name="input" #input (input)="markText(input.value)">
    <p>
      Hello magic-string !
    </p>
    <div #content [hidden]="true">
      <ng-content></ng-content>
    </div>
    <div [innerHTML]="controlledContent"></div>
  `,
  styles: [`
    .mark {
      background-color: yellow !important;
    }
  `],
  encapsulation: ViewEncapsulation.None
})
export class MagicStringComponent {

  @ViewChild('content', { static: true, read: ElementRef }) content: ElementRef | undefined;

  originalContent: string | undefined;
  controlledContent: string | undefined;

  ngOnInit() {
    this.controlledContent = this.originalContent=this.content?.nativeElement.textContent;
  }

  markText(value: any) {
    this.controlledContent=this.originalContent
    this.controlledContent = this.originalContent?.replace(new RegExp(value, 'g'), `<span class="mark">${value}</span>`);
    console.log('value from library', value);
  }
}
